//+------------------------------------------------------------------+
//|                                             Aroon oscillator.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  Silver
#property indicator_color2  LimeGreen
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_minimum -101
#property indicator_maximum  101


extern int            AroonPeriod     = 25;
extern double         Filter          = 50;
extern int            PriceFilter     =  5;
extern ENUM_MA_METHOD PriceFilterType =  MODE_SMA;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double priceh[];
double pricel[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,priceh);
   SetIndexBuffer(6,pricel);
      SetLevelValue(0, Filter);
      SetLevelValue(1,-Filter);
      PriceFilter = MathMax(PriceFilter,1);
   IndicatorShortName("Aroon oscillator ("+AroonPeriod+","+PriceFilter+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      if (buffer1[limit] >  Filter) CleanPoint(limit,buffer2,buffer3);
      if (buffer1[limit] < -Filter) CleanPoint(limit,buffer4,buffer5);
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      priceh[i] = iMA(NULL,0,PriceFilter,0,PriceFilterType,PRICE_HIGH,i);
      pricel[i] = iMA(NULL,0,PriceFilter,0,PriceFilterType,PRICE_LOW ,i);
      double AroonUp = 100.0*(AroonPeriod-ArrayMaximum(priceh,AroonPeriod+1,i)+i)/AroonPeriod;
      double AroonDn = 100.0*(AroonPeriod-ArrayMinimum(pricel,AroonPeriod+1,i)+i)/AroonPeriod;
         buffer1[i] = AroonUp-AroonDn;
         buffer2[i] = EMPTY_VALUE;
         buffer3[i] = EMPTY_VALUE;
         buffer4[i] = EMPTY_VALUE;
         buffer5[i] = EMPTY_VALUE;
                  if (buffer1[i]> Filter) PlotPoint(i,buffer2,buffer3,buffer1);
                  if (buffer1[i]<-Filter) PlotPoint(i,buffer4,buffer5,buffer1);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}